using System.Runtime.InteropServices;
namespace FRB_Ns
{
    public class FRB
    {
        public const ushort NoError = 0;
        public const ushort DriverOpenError = 1;
        public const ushort DriverNoOpen = 2;
        public const ushort GetDriverVersionError = 3;
        public const ushort FindBoardError = 4;
        public const ushort ExceedBoardNumber = 5;
        public const ushort InputParameterError = 6;
       
      
        [DllImport("FRB.dll", EntryPoint = "FRB_DriverInit")]
        public static extern ushort DriverInit(out ushort wTotalBoards);

        [DllImport("FRB.dll", EntryPoint = "FRB_DriverClose")]
        public static extern void DriverClose();

        [DllImport("FRB.dll", EntryPoint = "FRB_ActiveBoard")]
        public static extern ushort ActiveBoard(ushort wBoardNo);


        [DllImport("FRB.dll",EntryPoint ="FRB_GetDllVersion")]
        public static extern ushort GetDllVersion();
 

        [DllImport("FRB.dll",EntryPoint ="FRB_GetDriverVersion")]
        public static extern ushort GetDriverVersion(out ushort wDriverVersion);


        [DllImport("FRB.dll", EntryPoint = "FRB_GetConfigAddressSpace")]
        public static extern uint GetConfigAddressSpace(ushort wBoardNo, uint wAddrBase, ushort wIrqNo, ushort wSubVendor, ushort wSubDevice, ushort wSubAux, ushort wSlotBus, ushort wSlotDevice);


        [DllImport("FRB.dll",EntryPoint ="FRB_SendSA")]
        public static extern ushort SendSA(ushort wPort, ushort SAn, ushort wOutputData);
    
        [DllImport("FRB.dll",EntryPoint ="FRB_ReceiveRA")]
        public static extern ushort ReceiveRA(ushort wPort, ushort RAn, out ushort wInputData);
     

        [DllImport("FRB.dll",EntryPoint ="FRB_ReadRAStatus")]
        public static extern ushort ReadRAStatus(short wPort, byte bRAStatus);



        private int DriverOpened = 0;

   


        public FRB()//constroctor
        {
            DriverOpened = 0;
        }
        ~FRB()
        {
            if (DriverOpened != 0)
            {
                DriverOpened = 0;
                DriverClose();
            }
        }
    }
}